VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Pig latin translator"
   ClientHeight    =   2496
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3744
   LinkTopic       =   "Form1"
   ScaleHeight     =   2496
   ScaleWidth      =   3744
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtTranslation 
      Height          =   612
      Left            =   1320
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   1080
      Width           =   2412
   End
   Begin VB.CommandButton cmdTranslate 
      Caption         =   "Translate into pig latin!"
      Height          =   372
      Left            =   966
      TabIndex        =   2
      Top             =   2040
      Width           =   1812
   End
   Begin VB.TextBox txtSource 
      Height          =   612
      Left            =   1320
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   2412
   End
   Begin VB.Label Label2 
      Caption         =   """translation"""
      Height          =   372
      Left            =   240
      TabIndex        =   4
      Top             =   1200
      Width           =   972
   End
   Begin VB.Label Label1 
      Caption         =   "Enter text"
      Height          =   372
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   972
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdTranslate_Click()
  
  Dim Phrase$, Tokens() As String
  Dim PigWord$, I As Integer, T$, Temp As String
 
  Phrase$ = txtSource.Text
  Temp = ReplaceDelimiters(Phrase$, ".", ",", "!", ":", ";", "?")
  Temp = SuperTrim(Temp)
  If Len(Temp) = 0 Then
    MsgBox "Please enter some text!"
    txtSource.Text = vbNullString
    txtSource.SetFocus
    Exit Sub
  End If
  Tokens = Split(Temp)
  For I = 0 To UBound(Tokens)
     PigWord$ = Latinize$(Tokens(I))
     T$ = T$ + PigWord$ + Space$(1)
  Next I
  txtTranslation.Text = T$
  Dim YesNo As Integer
  YesNo = MsgBox("Done! - Click on Yes to enter more text, no to end", vbYesNo)
    If YesNo = vbYes Then
      txtSource.Text = vbNullString
      txtTranslation = vbNullString
      txtSource.SetFocus
     Else
      End
    End If
End Sub

Public Function Latinize$(A$)
  Dim FirstChar$
  If Len(A$) = 1 Then
    Latinize$ = A$
  Else
    FirstChar$ = UCase$(Left(A$, 1))
    Select Case FirstChar$
      Case "A", "E", "I", "O", "U"
        Latinize$ = A$ + "way"
      Case Is < "A"
        Latinize$ = A$
      Case Is > "Z"
        Latinize$ = A$
      Case Else
        Latinize$ = ShiftCons$(A$) + "ay"
    End Select
  End If
End Function

Public Function ShiftCons$(A$)
  ' local variables
  Dim Count As Integer, Done As Integer
  Dim NextChar As String

  Count = 1
  Done = False
  Do
    NextChar = UCase$(Mid(A$, Count, 1))
    Select Case NextChar
      Case "A", "E", "I", "O", "U"
        Done = True
      Case "Q"
        Count = Count + 2
      Case Else
        Count = Count + 1
    End Select
  Loop Until Done Or Count > Len(A$)
  ShiftCons$ = Mid(A$, Count) + Left(A$, Count - 1)
End Function

Public Function SuperTrim(TheString As String) As String
  Dim Temp As String, DoubleSpaces As String
  DoubleSpaces = Chr(32) & Chr(32)
  Temp = Trim(TheString)
  Temp = Replace(Temp, DoubleSpaces, Chr(32))
  Do Until InStr(Temp, DoubleSpaces) = 0
    Temp = Replace(Temp, DoubleSpaces, Chr(32))
  Loop
  SuperTrim = Temp
End Function
Public Function ReplaceDelimiters(TheString As String, ParamArray Delim()) As String
  Dim Delimiter As Variant, Temp As String, DoubleDelim As String
  Temp = TheString
  For Each Delimiter In Delim
     DoubleDelim = Delimiter & Delimiter
     Do Until InStr(Temp, DoubleDelim) = 0
       Temp = Replace(Temp, DoubleDelim, Delimiter)
     Loop
     Temp = Replace(Temp, Delimiter, Chr(32))
  Next
  ReplaceDelimiters = Temp
End Function

