VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Sorting test form"
   ClientHeight    =   2628
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3744
   LinkTopic       =   "Form1"
   ScaleHeight     =   2628
   ScaleWidth      =   3744
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   2532
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "sorting example.frx":0000
      Top             =   0
      Width           =   3612
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private RndInt1 As Integer, RndInt2 As Integer

Private Sub Form_Load()
Show
Dim B$(2000)
Dim I As Integer
Randomize
For I = 1 To 2000
  RndInt1 = Int(26 * Rnd(1)): RndInt2 = Int(26 * Rnd(1))
  B$(I) = Chr$(RndInt1 + 65) & Chr$(RndInt2 + 65)
  RndInt1 = Int(26 * Rnd(1)): RndInt2 = Int(26 * Rnd(1))
  B$(I) = B$(I) & Chr$(RndInt1 + 65) & Chr$(RndInt2 + 65)
Next I
Dim StartTime As Single
StartTime = Timer
InsertionSort B$()
Dim EndTime As Single
EndTime = Timer
Dim Temp As String
For I = 1 To 2000
  Temp = Temp & B$(I) & "   "
Next I
Text1.Text = Temp
MsgBox "Insertion sort for 2000 entries took " & EndTime - StartTime & " seconds"
Text1.Visible = False

StartTime = Timer
RippleSort B$()
EndTime = Timer
MsgBox "Ripple sort for 2000 entries took " & EndTime - StartTime & " seconds"
ShellSortTiming
Temp = vbNullString
For I = 1 To 1000
  Temp = Temp & B$(I) & "   "
Next I
Text1.Text = Temp
End Sub

Private Sub RippleSort(A$())
  'Local variables NumOfEntries%, NumOfTimes%, I%, J%
  Dim NumOfEntries%, NumOfTimes%, I%, J%

  NumOfEntries% = UBound(A$)
  NumOfTimes% = NumOfEntries% - 1
  For I% = LBound(A$) To NumOfTimes%
    For J% = I% + 1 To NumOfEntries%
      If A$(J%) < A$(I%) Then SWAP A$(J%), A$(I%)
    Next J%
  Next I%
End Sub

Sub SWAP(X As String, Y As String)
Dim Temp As String
  Temp = X
  X = Y
  Y = Temp
End Sub

Private Sub InsertionSort(A$())
  'LOCAL Variables are NumOfEntries%, I%, J%, Temp$
  Dim NumOfEntries%, I%, J%, Temp$

  NumOfEntries% = UBound(A$)
  For I% = 2 To NumOfEntries%
    Temp$ = A$(I%)
    For J% = I% - 1 To 1 Step -1
      If Temp$ >= A$(J%) Then Exit For
      A$(J% + 1) = A$(J%)
    Next J%
    A$(J% + 1) = Temp$
  Next I%
End Sub

Public Sub ShellSort(A$())
  'LOCAL variables are NumOfEntries, Increm, J, Temp$
  Dim NumOfEntries As Long, I As Long
  Dim Increm As Long, J As Long, Temp$
  NumOfEntries = UBound(A$)
  Increm = NumOfEntries \ 2
  Do Until Increm < 1
    For I = Increm + 1 To NumOfEntries
      Temp$ = A$(I)
      For J = I - Increm To 1 Step -Increm
        If Temp$ >= A$(J) Then Exit For
        A$(J + Increm) = A$(J)
      Next J
      A$(J + Increm) = Temp$
    Next I
    Increm = Increm \ 2
  Loop
End Sub


Private Sub ShellSortTiming()
Dim StartTime As Single, EndTime As Single, I As Long

Dim B$(20000)
For I = 1 To 20000
  RndInt1 = Int(26 * Rnd(1)): RndInt2 = Int(26 * Rnd(1))
  B$(I) = Chr$(RndInt1 + 65) & Chr$(RndInt2 + 65)
  RndInt1 = Int(26 * Rnd(1)): RndInt2 = Int(26 * Rnd(1))
  B$(I) = B$(I) & Chr$(RndInt1 + 65) & Chr$(RndInt2 + 65)
Next I
StartTime = Timer
ShellSort B$()
EndTime = Timer
MsgBox "Shell sort for 20,000 entries took " & EndTime - StartTime & " seconds!"
End Sub
