VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Square made up of via a control array"
   ClientHeight    =   2496
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3744
   LinkTopic       =   "Form1"
   ScaleHeight     =   2496
   ScaleWidth      =   3744
   StartUpPosition =   3  'Windows Default
   Begin VB.Label lblBox 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Label1"
      Height          =   372
      Index           =   0
      Left            =   1440
      TabIndex        =   0
      Top             =   1080
      Visible         =   0   'False
      Width           =   972
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim fNumberOfDim As Integer, fSize As Integer
Dim fLabelSize As Integer, Magic() As Integer
 Private Sub Form_Load()
'Local variables
  Dim I As Integer, BoxSize As Single
  Dim X As String, L As String
  Dim LabelSizeMessage As String
  
  Show
  WindowState = 2                         'maximal
   
  'get number of rows/columns
  X = InputBox("Number of dimensions?")
  fNumberOfDim = Val(X)
  LabelSizeMessage = CheckDimensionNumber(fNumberOfDim)
  Do Until LabelSizeMessage = "OK"
     X = InputBox(LabelSizeMessage & "Reenter the number of dimensions.")
     fNumberOfDim = Val(X)
     LabelSizeMessage = CheckDimensionNumber(fNumberOfDim)
  Loop
  ' get size
  L = InputBox("Size of Labels?")
  fLabelSize = Val(L)
  LabelSizeMessage = fLabelSizeOk(fLabelSize)
  Do Until LabelSizeMessage = "OK"
    L = InputBox(LabelSizeMessage & " Please reenter label size")
    fLabelSize = Val(L)
    LabelSizeMessage = fLabelSizeOk(fLabelSize)
  Loop
 
  MsgBox "Please click on the form in order to see the magic square."
 End Sub


Sub GetDimensions()
'Local variables
  Dim I As Integer, BoxSize As Single
  Dim X As String, L As String
  Dim LabelSizeMessage As String
  
  'Get number of rows/columns
  X = InputBox("Number of dimensions?")
  fNumberOfDim = Val(X)
  'Call a function to check the number of dimensions.
  'This will return a message that we use for the loop.
  LabelSizeMessage = CheckDimensionNumber(fNumberOfDim)
  Do Until LabelSizeMessage = "OK"
     X = InputBox(LabelSizeMessage & "Reenter the number of dimensions.")
     fNumberOfDim = CInt(X)
     LabelSizeMessage = CheckDimensionNumber(fNumberOfDim)
  Loop
         
  'Similarly we call a similar function to check the size of the labels.
  L = InputBox("Size of Labels?")
  fLabelSize = CInt(L)
  LabelSizeMessage = fLabelSizeOk(fLabelSize)
  Do Until LabelSizeMessage = "OK"
    L = InputBox(LabelSizeMessage & " Please reenter label size")
    fLabelSize = CInt(L)
    LabelSizeMessage = fLabelSizeOk(fLabelSize)
  Loop
 
 End Sub

Function CheckDimensionNumber(X As Integer) As String
    If X Mod 2 <> 1 Then
      CheckDimensionNumber = "Number of rows/columns must be odd. "
    ElseIf X > 15 Then
       CheckDimensionNumber = "Number of rows/columns must be < 16. "
    Else
       CheckDimensionNumber = "OK"
    End If
 End Function
Function fLabelSizeOk(X As Integer) As String
  Dim SpacedUsed As Integer, MaximumWidth As Integer
  MaximumWidth = fNumberOfDim * fNumberOfDim
 'MaximumWidth is the width of the largest number that we use
  MaximumWidth = TextWidth(Trim(Str$(MaximumWidth)))
  SpacedUsed = X * fNumberOfDim
  If SpacedUsed > ScaleHeight Or SpacedUsed > ScaleWidth Then
     fLabelSizeOk = "Labels too large. "
  ElseIf X < MaximumWidth Or X < TextHeight("1") Then
    fLabelSizeOk = "Labels too small. "
  Else
     fLabelSizeOk = "OK"
  End If
End Function

 Private Sub Form_Click()
  Static BoxesMade As Integer
  Cls
  If Not (BoxesMade) Then
    MakeBoxes fLabelSize
    BoxesMade = True
  End If
  MakeMagic ' calls the MakeMagic routine
  LocateBoxes fLabelSize, fNumberOfDim
End Sub

Private Sub MakeBoxes(HowBig)
  Dim I As Integer

  lblBox(0).Visible = 0   'temp hide original label
  lblBox(0).Height = HowBig
  lblBox(0).Width = HowBig
  fSize = fNumberOfDim * fNumberOfDim
  For I = 1 To fSize - 1     'already have one label lblBox(0)
    Load lblBox(I)
    lblBox(I).Height = HowBig
    lblBox(I).Width = HowBig
  Next I
End Sub

 Private Sub LocateBoxes(HowBig As Integer, Number As Integer)

  Dim I As Integer, Row As Integer
  Dim Column As Integer
  Dim StartWidth As Integer, StartHeight As Integer
  Dim CurrentHeight As Integer, CurrentWidth As Integer

  StartHeight = ScaleHeight / 2 - ((Number / 2) * HowBig)
  StartWidth = ScaleWidth / 2 - ((Number / 2) * HowBig)
  For I = 0 To fSize - 1
    Row = I \ Number
    Column = I Mod Number
    CurrentHeight = StartHeight + (Row * HowBig)
    CurrentWidth = StartWidth + (Column * HowBig)
    lblBox(I).Move CurrentWidth, CurrentHeight
    'this next line is the changed line
    lblBox(I).Caption = Trim(Str$(Magic(Row + 1, Column + 1)))
    lblBox(I).Visible = True
  Next I
End Sub
 Private Sub MakeMagic()
  'local variables
  Dim I As Integer, RowNumber As Integer, ColNumber As Integer
  Dim NewRow As Integer, NewCol As Integer
  ReDim Magic(1 To fNumberOfDim, 1 To fNumberOfDim)

  RowNumber = 1
  ColNumber = (fNumberOfDim \ 2) + 1
  Magic(RowNumber, ColNumber) = 1
  For I = 2 To fSize
    If RowNumber = 1 And ColNumber = fNumberOfDim Then
    ' at right hand corner
      NewRow = 2
      NewCol = ColNumber
    Else
      'move up one row and to the right
      NewRow = RowNumber - 1
      NewCol = ColNumber + 1 'move up one row and to the right
      'next line means we have gone off the top
      If NewRow < 1 Then NewRow = NewRow + fNumberOfDim
      ' above line means gone of the top
      'next line means we have gone off the right
      If NewCol > fNumberOfDim Then NewCol = NewCol - fNumberOfDim
      'above line means gone of the right
    End If
    'find empty slot by going down row by row
    Do Until Magic(NewRow, NewCol) = 0
      NewRow = RowNumber + 1
      NewCol = ColNumber
    Loop
    RowNumber = NewRow
    ColNumber = NewCol
    Magic(RowNumber, ColNumber) = I
  Next I
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Unload Me
  End
End Sub

