VERSION 5.00
Begin VB.Form frmDrawPie 
   Caption         =   "Draw Pie"
   ClientHeight    =   3192
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3192
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmDrawPie"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const TWOPIE = 2 * 3.14159
Private Sub Form_Load()
  Dim A(1 To 5) As Single
  Dim I As Integer
  For I = 1 To 5
    A(I) = 50 + 50 * Rnd
  Next I
  AutoRedraw = True
  Call MakePie(A)
End Sub

Sub MakePie(A() As Single)
  ' This procedure takes an array of positive single
  ' precision entries and
  ' creates a pie chart using proportions determined by the
  ' array.
 
  ' LOCAL variables: I,First,Last,Total,StartAngle,EndAngle
  ' form level variable is assumed to be fTwoPie
  ' TWOPIE should be a little less than 8*Atn(1)
  ' say 2*3.14159

  Dim I As Integer, First As Integer, Last As Integer
  Dim Total As Single, StartAngle As Single
  Dim EndAngle As Single, LastAngle As Single

  First = LBound(A, 1)
  Last = UBound(A, 1)
  Total = 0
  For I = First To Last
    Total = Total + A(I)
  Next I
  Scale (-1, 1)-(1, -1)
  StartAngle = -TWOPIE
  For I = First To Last
    EndAngle = ((A(I) / Total) * TWOPIE) + StartAngle
    Circle (0, 0), 0.5, , StartAngle, EndAngle
    StartAngle = EndAngle
  Next I
End Sub

