Attribute VB_Name = "Module1"
Global DiskInfo() As Integer
Global HowWide, HowHigh As Single
Global NumberOfDisks As Integer

Public Sub Init()
 Dim I As Integer, M$
 HowWide = frmTowerOfBrahma.ScaleWidth       'global variable
 HowHigh = frmTowerOfBrahma.ScaleHeight      'ditto
   frmTowerOfBrahma.DrawWidth = 9
   For I = 1 To 3
     frmTowerOfBrahma.Line ((I / 4) * HowWide, HowHigh)-((I / 4) * _
HowWide, 250)
   Next I
   M$ = InputBox$("Number of disks - 15 or less?")
   NumberOfDisks = Val(M$)
   Do Until NumberOfDisks > 0 And NumberOfDisks < 16
     M$ = InputBox$("Number of disks - 15 or less?")
     NumberOfDisks = Val(M$)
   Loop

 ReDim DiskInfo(NumberOfDisks, 3)
 ' Put Picture boxes

 For I = 1 To NumberOfDisks
  DiskInfo(I, 1) = NumberOfDisks + 1 - I
  frmTowerOfBrahma.Disk(I).Move (HowWide / 4) - 600 + 30 * I, _
  HowHigh - (285 * I), 1200 - (65 * I), 285
  frmTowerOfBrahma.Disk(I).BackColor = QBColor(I)
  frmTowerOfBrahma.Disk(I).Visible = True
  frmDirections.Refresh
 Next I
 DiskInfo(0, 1) = NumberOfDisks
 DiskInfo(0, 2) = 0
 DiskInfo(0, 3) = 0
End Sub

Public Sub SolveTowerOfHanoi(Disks As Integer, FromTower As Integer, _
ToTower As Integer, UsingTower As Integer)

If Disks = 1 Then
   MoveADisk FromTower, ToTower
Else
   SolveTowerOfHanoi (Disks - 1), FromTower, UsingTower, ToTower
   MoveADisk FromTower, ToTower
   SolveTowerOfHanoi (Disks - 1), UsingTower, ToTower, FromTower
End If
End Sub

Sub MoveADisk(FromTower As Integer, ToTower As Integer)
  DiskNumber = DiskInfo(0, FromTower)
  DiskIndex = DiskInfo(DiskNumber, FromTower)
  DiskInfo(DiskNumber, FromTower) = 0
  DiskInfo(0, FromTower) = DiskInfo(0, FromTower) - 1
  DiskInfo(0, ToTower) = DiskInfo(0, ToTower) + 1
  DiskNumber = DiskInfo(0, ToTower)
  If DiskNumber > NumberOfDisks Then
    Exit Sub
  Else
    DiskInfo(DiskNumber, ToTower) = DiskIndex
  End If

  NewLeft = (HowWide * ToTower / 4) - frmTowerOfBrahma.Disk(NumberOfDisks + 1 - _
  DiskIndex).Width / 2
  NewTop = HowHigh - (DiskNumber * 285)
  frmTowerOfBrahma.Disk(NumberOfDisks + 1 - DiskIndex).Move NewLeft, NewTop
  frmTowerOfBrahma.Refresh
 End Sub




