VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Mortgage Calculator II"
   ClientHeight    =   4416
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   5616
   LinkTopic       =   "Form1"
   ScaleHeight     =   4416
   ScaleWidth      =   5616
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtMortgageTable 
      Height          =   1452
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   2400
      Width           =   5532
   End
   Begin VB.TextBox txtMortgageTerm 
      Height          =   372
      Left            =   3840
      TabIndex        =   3
      Top             =   1476
      Width           =   972
   End
   Begin VB.TextBox txtInterestRate 
      Height          =   372
      Left            =   3840
      TabIndex        =   2
      Top             =   840
      Width           =   972
   End
   Begin VB.TextBox txtMortgageAmount 
      Height          =   372
      Left            =   3840
      TabIndex        =   1
      Top             =   120
      Width           =   972
   End
   Begin VB.CommandButton cmdCalculate 
      Caption         =   "&Calculate"
      Height          =   372
      Left            =   2400
      TabIndex        =   0
      Top             =   3960
      Width           =   972
   End
   Begin VB.Label lblMortgageTable 
      Caption         =   "Label4"
      Height          =   372
      Left            =   0
      TabIndex        =   8
      Top             =   2040
      Width           =   5412
   End
   Begin VB.Label Label3 
      Caption         =   "Number of years?"
      Height          =   372
      Left            =   480
      TabIndex        =   6
      Top             =   1476
      Width           =   1692
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Interest Rate (USE 7 FOR 7% ETC.)"
      Height          =   192
      Left            =   480
      TabIndex        =   5
      Top             =   840
      Width           =   2520
   End
   Begin VB.Label Label1 
      Caption         =   "Amount "
      Height          =   372
      Left            =   480
      TabIndex        =   4
      Top             =   120
      Width           =   1692
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
 

Private Sub cmdCalculate_Click()
  'Calculates a mortgage table using original amounts
  'but having the interest rate move up by 1/8%
  'local variables and constants
  Dim SpaceChar As String, T$
  Dim Years As Integer, Payment As Currency
  Dim MonthInt As Single, Principal As Currency
  Dim Percent As Single, Interest  As Single
  Dim StartInterest As Single, EndInterest As Single
  Dim Amount As Currency, StartAmount As Currency
  Dim EndAmount As Currency
  
  Const DAMOUNT = "###.00"
  Const IRATE = "00.00%"

 'Get info
  Years = CInt(txtMortgageTerm.Text)
  Principal = CCur(txtMortgageAmount.Text)
  Percent = CInt(txtInterestRate.Text) / 100
  StartInterest = Percent - 0.01            '1% change
  EndInterest = Percent + 0.01
  StartAmount = Principal - 25000
  EndAmount = Principal + 25000
  For Amount = StartAmount To EndAmount Step 5000
    For Interest = StartInterest To EndInterest Step 0.00125
      MonthInt = Interest / 12
          Payment = Principal * MonthInt / (1 - (1 / (1 + MonthInt)) _
^ (Years * 12))
      T$ = T$ & Format$(Interest, IRATE) & Space$(20) + _
  "for " & Amount & " =" & Space$(7) & Format$(Payment, DAMOUNT) & vbCrLf
    Next Interest
    txtMortgageTable.Text = T$
  Next Amount
End Sub

Private Sub Form_Load()
  lblMortgageTable.Font.Name = "Courier New"
  txtMortgageTable.Font.Name = "Courier New"
  lblMortgageTable.Caption = "Interest Rate" + Space$(30) + "Payment"
End Sub

