VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Postage calculator With Validation"
   ClientHeight    =   2496
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   4344
   LinkTopic       =   "Form1"
   ScaleHeight     =   2496
   ScaleWidth      =   4344
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCalculate 
      Caption         =   "Calculate postage"
      Height          =   372
      Left            =   1200
      TabIndex        =   2
      Top             =   2040
      Width           =   1812
   End
   Begin VB.TextBox txtWeight 
      Height          =   372
      Left            =   2280
      TabIndex        =   0
      Top             =   480
      Width           =   1452
   End
   Begin VB.Label Label1 
      Caption         =   "Enter the weight in ounces"
      Height          =   372
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1932
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Function Postage(Weight As Single) As Currency
  'Calculate the cost, in cents, of mailing
  'a first-class letter of a given weight in ounces
  'the rule is .32 for the first ounce and the .23 for
   'each additional ounce or fraction part

  If Int(Weight) = Weight Then
    Postage = 0.32 + (0.23 * (Weight - 1))
  Else
    Postage = 0.32 + (0.23 * (Int(Weight)))
  End If
End Function

Function IsPositive(X As Variant) As Boolean
 If IsNumeric(X) Then
   If CSng(X) > 0 Then
     IsPositive = True
   Else
     IsPositive = False
   End If
 Else
   IsPositive = False
 End If
End Function
Private Sub cmdCalculate_Click()
'local variables:
  Dim WeightOfLetter As Single, Msg$

If IsPositive(txtWeight.Text) Then
  WeightOfLetter = CSng(txtWeight.Text)
  Msg$ = "The cost to mail that letter is "
  Msg$ = Msg$ & Format(Postage(WeightOfLetter), "Currency")
  MsgBox Msg$
Else
  Beep
  MsgBox "A letter must have positive weight!"
 txtWeight.Text = ""
End If
End Sub


