VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Parsing text"
   ClientHeight    =   2496
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3744
   LinkTopic       =   "Form1"
   ScaleHeight     =   2496
   ScaleWidth      =   3744
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtNextWord 
      Height          =   372
      Left            =   960
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   1200
      Width           =   2052
   End
   Begin VB.CommandButton cmdFindWords 
      Caption         =   "Find next word"
      Height          =   372
      Left            =   1200
      TabIndex        =   2
      Top             =   2040
      Width           =   1332
   End
   Begin VB.TextBox txtString 
      Height          =   612
      Left            =   1320
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   240
      Width           =   2412
   End
   Begin VB.Label Label1 
      Caption         =   "Enter text"
      Height          =   372
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   972
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Sub cmdFindWords_Click()
  Dim Temp As String, Tokens() As String
  
  Static CurrentIndex As Integer
  txtString.Locked = True
  Temp = ReplaceDelimiters(txtString.Text, ".", ",", "!", ":", ";", "?")
  Temp = SuperTrim(Temp)
  If Len(Temp) = 0 Then
    MsgBox "Please enter some text!"
    txtString.Locked = False
    txtString.Text = vbNullString
    txtString.SetFocus
    Exit Sub
  End If
  Tokens = Split(Temp)
  txtNextWord.Text = "Word #" & (CurrentIndex + 1) _
  & " = " & Tokens(CurrentIndex)
  CurrentIndex = CurrentIndex + 1
  Dim YesNo As Integer
  If CurrentIndex > UBound(Tokens) Then
    YesNo = MsgBox("Done! - Click on Yes to enter more text, no to end", vbYesNo)
    If YesNo = vbYes Then
      CurrentIndex = 0
      txtNextWord.Text = vbNullString
      txtString.Text = vbNullString
      txtString.Locked = False
      txtString.SetFocus
    Else
      End
    End If
  End If
  End Sub

Public Function SuperTrim(TheString As String) As String
  Dim Temp As String, DoubleSpaces As String
  DoubleSpaces = Chr(32) & Chr(32)
  Temp = Trim(TheString)
  Temp = Replace(Temp, DoubleSpaces, Chr(32))
  Do Until InStr(Temp, DoubleSpaces) = 0
    Temp = Replace(Temp, DoubleSpaces, Chr(32))
  Loop
  SuperTrim = Temp
End Function
Public Function ReplaceDelimiters(TheString As String, ParamArray Delim()) As String
  Dim Delimiter As Variant, Temp As String, DoubleDelim As String
  Temp = TheString
  For Each Delimiter In Delim
     DoubleDelim = Delimiter & Delimiter
     Do Until InStr(Temp, DoubleDelim) = 0
       Temp = Replace(Temp, DoubleDelim, Delimiter)
     Loop
     Temp = Replace(Temp, Delimiter, Chr(32))
  Next
  ReplaceDelimiters = Temp
End Function


