VERSION 5.00
Begin VB.Form frmSketch 
   AutoRedraw      =   -1  'True
   Caption         =   "Visual Basic A-Sketch"
   ClientHeight    =   3192
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3192
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmSketch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private fPixelHeight As Single, fPixelWidth As Single
Private fWhereX As Single, fWhereY As Single

Private Sub Form_Load()
  AutoRedraw = True
  ScaleMode = 3                      'Pixels
  fPixelHeight = ScaleHeight
  fPixelWidth = ScaleWidth
  fWhereX = fPixelWidth / 2
  fWhereY = fPixelHeight / 2
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
Unload frmStartup
Unload Me
End
End Sub

Private Sub Form_Resize()
  fPixelHeight = ScaleHeight
  fPixelWidth = ScaleWidth
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Dim YesNo%
  Select Case KeyCode
    Case vbKeyLeft
      If fWhereX <= 0 Then         'don't go off drawing area
        fWhereX = 0                  'but round down may occur
      Else
        fWhereX = fWhereX - 1        'move left 1
      End If
    Case vbKeyRight
      If fWhereX >= fPixelWidth Then
        fWhereX = fPixelWidth
      Else
        fWhereX = fWhereX + 1          ' right 1
      End If
    Case vbKeyUp                    'up 1
      If fWhereY <= 0 Then
        fWhereY = 0
      Else
        fWhereY = fWhereY - 1
      End If
    Case vbKeyDown
      If fWhereY >= fPixelHeight Then
        fWhereY = fPixelHeight
      Else
        fWhereY = fWhereY + 1
      End If
    Case vbKeyEnd
      YesNo% = MsgBox("Are you sure you want to end?", vbYesNo)
      If YesNo% = vbYes Then End          '6 is Yes button click
    Case Else
      Beep
  End Select
   PSet (fWhereX, fWhereY)
End Sub

