VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Recursive File Deletion Demo"
   ClientHeight    =   2496
   ClientLeft      =   36
   ClientTop       =   324
   ClientWidth     =   3744
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2496
   ScaleWidth      =   3744
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim FSO As FileSystemObject

Private Sub Form_Load()
Dim TheExtension As String, TheFolder As Folder
Dim WhereToStart As String, YesNo As Integer

  Set FSO = New FileSystemObject

  WhereToStart = InputBox("Please enter the folder or drive to work with - use C:\ for example")
  Set TheFolder = FSO.GetFolder(WhereToStart)

  TheExtension = InputBox("What extension to delete-don't use a '.', example: tmp")
  TheExtension = UCase(TheExtension)
  
  Message = "Are you sure you want to delete ALL files in ALL sub-directories "
  Message = Message & "of " & WhereToStart & " the extension " & vbCrLf
  Message = Message & vbCrLf & vbTab & vbTab & vbTab & TheExtension
  YesNo = MsgBox(Message, vbYesNo)
  If YesNo = vbYes Then
     Message = "Press Enter or click on OK to start the process. "
     Message = Message & "Note, this can take some time. An information "
     Message = Message & "box will be updated as each directory is processed."
     MsgBox Message
     Show
     Me.MousePointer = vbHourglass
     WorkWithSubFolders TheFolder, TheExtension
  Else
    End
  End If
  MsgBox "Done! Click on OK or press Enter to end."
  End
End Sub

Sub WorkWithSubFolders(ByVal AFolder As Folder, ByVal TheExtension As String)
  Dim MoreFolders As Folders, TempFolder As Folder
  Static TheCount As Integer
  TheCount = TheCount + 1
  Message = "Have worked so far with " & TheCount _
    & " folders."
  Me.Cls
  Me.CurrentX = (ScaleWidth / 2) - (TextWidth(Message) / 2)
  Me.CurrentY = (ScaleHeight / 2) - (TextHeight(Message) / 2)
  Me.Print Message
  KillFilesWithExtensionIn AFolder, TheExtension
  Set MoreFolders = AFolder.SubFolders
  For Each TempFolder In MoreFolders
    WorkWithSubFolders TempFolder, TheExtension
  Next
End Sub

Sub KillFilesWithExtensionIn(AFolder As Folder, TheExtension As String)
  Dim AFile As File, TheFiles As Files
  On Error Resume Next
  Set TheFiles = AFolder.Files
  For Each AFile In TheFiles
    If UCase(FSO.GetExtensionName(AFile.Path)) = TheExtension Then
      AFile.Delete
    End If
  Next
End Sub

